// Employee.java

import java.util.Vector;

/**
 * abstract class, so it cannot be instantiated.
 * implements Comparable, so Collections.sort(list) can use it
 */
public abstract class Employee implements Salary, Comparable {

	// protected to make it accessible only to derived classes
	protected int accountNumber;
	protected String firstName;
	protected String lastName;
	protected double salary;
	protected String type;
	protected Vector randomNumbers = new Vector();

	// recursive method to generate random number
	protected int getRandomNumber() {
		int R = (int)(Math.random() * 999);

		// wrap into Integer object, so Vector can store it
		Integer rI = new Integer(R);

		// check to see if number is greater than 99
		// also, it is not already there in the Vector
		if(R >= 100 && !randomNumbers.contains(rI)) {
			// meets the condtion, break from recursion
			randomNumbers.add(rI);
			return R;
		} else {

			// recurse until the condition is met
			return getRandomNumber();
		}
	}

	// method to add increment to salary
	public void updateSalary(int percent) {
		salary += (salary * percent)/100;
	}

	// set account number
	public void setAccountNumber(int number) {
		accountNumber = number;
	}

	// set first name
	public void setFirstName(String fname) {
		firstName = fname;
	}

	// set last name
	public void setLastName(String lname) {
		lastName = lname;
	}

	//set last name
	public void setSalary(double sal) {
		salary = sal;
	}

	// set emp type
	public void setType(String type) {
		this.type = type;
	}

	// get account number
	public int getAccountNumber() {
		return accountNumber;
	}

	// get first name
	public String getFirstName() {
		return firstName;
	}

	// get last name
	public String getLastName() {
		return lastName;
	}

	// get salary
	public double getSalary() {
		return salary;
	}

	public String getType() {
		return type;
	}

	// needed to sort
	// Used by the Collections.sort(list) method
	public int compareTo(Employee emp) {
		if(lastName.equals(emp.lastName)) {
			return firstName.compareTo(emp.firstName);
		}
		return lastName.compareTo(emp.lastName);
	}

	public void display() {
		System.out.println(accountNumber+"..."+firstName+" "+lastName+"..."+type+"..."+salary);
	}
}

