// EmployeeDriver.java

import java.io.*;

public class EmployeeDriver {

	static String[] types = {"Administrator", "Manager", "CEO"};
	static String type="", fname="", lname="", salary="";
	static Employee emp = null;	// current employee being added
	static boolean isAdded = false;	// check whether emp is added to DAO
	static BufferedReader stdin = null;
	static String input = "0";
	static double sal = 0.0;

	public static void main(String[] args) {

		EmployeeDAO dao = new EmployeeDAO();

		/* hard-code 5 employees */
		// add one admin asst
		Employee emp = new AdministrativeAssistant();
		emp.setAccountNumber(emp.getRandomNumber());
		emp.setFirstName("Nikhil");
		emp.setLastName("Betanabhotla");
		emp.setType("Admin");
		emp.setSalary(2345.00);
		emp.updateSalary(3);
		dao.add(emp);

		// add another admin asst
		emp = new AdministrativeAssistant();
		emp.setAccountNumber(emp.getRandomNumber());
		emp.setFirstName("Neha");
		emp.setLastName("Samant");
		emp.setType("Admin");
		emp.setSalary(2000.00);
		emp.updateSalary(3);
		dao.add(emp);

		// add one manager
		emp = new Manager();
		emp.setAccountNumber(emp.getRandomNumber());
		emp.setFirstName("Akhil");
		emp.setLastName("Betanabhotla");
		emp.setType("Manager");
		emp.setSalary(1234.00);
		emp.updateSalary(3);
		dao.add(emp);

		// add another manager
		emp = new Manager();
		emp.setAccountNumber(emp.getRandomNumber());
		emp.setFirstName("Jackie");
		emp.setLastName("Shroff");
		emp.setType("Manager");
		emp.setSalary(6789.00);
		emp.updateSalary(3);
		dao.add(emp);

		// add CEO
		emp = new CEO();
		emp.setAccountNumber(emp.getRandomNumber());
		emp.setFirstName("Nankhil");
		emp.setLastName("Nansoft");
		emp.setType("CEO");
		emp.setSalary(4321.00);
		emp.updateSalary(3);
		dao.add(emp);

		// user input

		try {
			input = displayMenu();
			while(true) {
				processUserInput(input,dao);
				input = displayMenu();
			}
		} catch(IOException igmore) { }

	}

	private static void print(EmployeeDAO dao) {
		// display
		System.out.println("A/c #...Name...Type...Updated Salary\n");
		int numEmps = dao.size();
		for(int i=0; i<numEmps; i++) {
			Employee E = dao.get(i);
			if(E instanceof AdministrativeAssistant) {
				AdministrativeAssistant asst = (AdministrativeAssistant)E;
				asst.display();
			} else if(E instanceof Manager) {
				Manager man = (Manager)E;
				man.display();

			} else if(E instanceof CEO) {
				CEO chief = (CEO)E;
				chief.display();
			}
		}
	}

	private static String displayMenu() throws IOException {
        stdin = new BufferedReader(
			new InputStreamReader (System.in));
		System.out.println("Valid Employee types are: Admin, Manager, CEO");
		System.out.println("1. Type");
		System.out.println("2. First Name");
		System.out.println("3. Last Name");
		System.out.println("4. Salary");
		System.out.println("5. Exit");
		System.out.print("\nChoose one option 1/2/3/4/5: ");
		String option = stdin.readLine();
		return option;
	}

	private static void processUserInput(String input,EmployeeDAO dao) throws IOException {
        // Data is input using a BufferedReader object that is composed from
        // an InputStream object, that is predefined in the java.lang package.
        // This InputStreamReader object is constructed from System.in.  From this
        // InputStreamReader object a BufferedReader is constructed to more
        // efficiently access the data.

		if(input.equals("1")) {	// type
			// With our object stdin, we can read a line of input as a String
			// using the readLine method:
			System.out.print("Enter employee type to add: ");
			type = stdin.readLine();
			// create employee and add to DAO
			if(type.equalsIgnoreCase("Admin")) {
				emp = new AdministrativeAssistant();
			} else if(type.equalsIgnoreCase("Manager")) {
				emp = new Manager();
			} else if(type.equalsIgnoreCase("CEO")) {
				emp = new CEO();
			}
			emp.setAccountNumber(emp.getRandomNumber());
			emp.setType(type);
			System.out.println("Employee created.");
		} else if(input.equals("2")) {	// first name
		    if(emp==null) return;
			System.out.print("Enter employee first name: ");
			fname = stdin.readLine();
			emp.setFirstName(fname);
			System.out.println("Employee first name added.");
		} else if(input.equals("3")) {	// last name
			if(emp==null) return;
			System.out.print("Enter employee last name: ");
			lname = stdin.readLine();
			emp.setLastName(lname);
			System.out.println("Employee last name added.");
		} else if(input.equals("4")) {	// salary
			if(emp==null) return;
			System.out.print("Enter employee salary: ");
			salary = stdin.readLine();
			sal = Double.parseDouble(salary);
			emp.setSalary(sal);
			System.out.println("Employee salary added.");
			emp.updateSalary(3);
			System.out.println("Employee salary updated.");
		} else if(input.equals("5")) {
			// release system resources
			stdin.close();
			if(emp != null) {
				dao.add(emp);
			}
			// display
			System.out.println("********************************");
			System.out.println("Unsorted");
			System.out.println("********************************");
			print(dao);
			dao.sort();
			System.out.println("********************************");
			System.out.println("Sorted");
			System.out.println("********************************");
			print(dao);
			System.exit(0);
		}
	}

}

